Public Class Form1

    Dim tempTime As String
    Dim tempDate As String
    Dim Data() As Byte

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        SerialPort1.Open()                  ' Open Serial Port , make sure setting is 9600,n,8,1
        Data = New Byte() {13}              ' Send Single byte 13 ( 0x0D ) to SC1602A to clear LCD
        SerialPort1.Write(Data, 0, 1)

    End Sub

    Private Sub Update_Time()

        Dim DT As Date

        DT = Now()                                              ' Retrieve current system time
        Label1.Text = Format(DT, "hh:mm:ss tt").PadLeft(13)     ' Display current time on screen, Add spaces to center aligned on LCD
        Label2.Text = Format(DT, "ddd, MMM d yyyy")             ' Display current date 
        If tempTime <> Label1.Text Then                         ' If time changes , update the LCD
            Data = New Byte() {11}                              ' Send LCD Home command
            SerialPort1.Write(Data, 0, 1)
            SerialPort1.Write(Label1.Text)                      ' Send the ASCII text of current time
        End If
        If tempDate <> Label2.Text Then                         ' If Date changes, update the LCD
            Data = New Byte() {254, 45, 1}                      ' Send clear row 1 command ( 254,45,1)
            SerialPort1.Write(Data, 0, 3)
            SerialPort1.Write(Label2.Text)                      ' Send the ASCII text of current date
        End If
        tempTime = Label1.Text
        tempDate = Label2.Text

    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Update_Time() ' Update time info every 500 ms

    End Sub
End Class
